/* $Id: CrowdAuthTagLib.groovy 28088 2008-04-02 22:25:13Z caulfield14 $ */

class CrowdAuthTagLib {

    def ifAllGranted = { attrs, body ->
        if (CrowdAuthUtils.getAuthenticatedPrincipalGroups(request)?.containsAll(attrs['role'].split(',').toList())) {
            out << body()
        }
    }

    def ifAnyGranted = { attrs, body ->
        for (role in attrs['role'].split(',').toList()) {
            if (CrowdAuthUtils.getAuthenticatedPrincipalGroups(request)?.contains(role)) {
                out << body()
            }
        }
    }

    def ifNotGranted = { attrs, body ->
//        for ()
    }

    def isAuthenticated = { attrs, body ->
        log.debug("CrowdAuthTagLib.isAuthenticated()")
        if (CrowdAuthUtils.isAuthenticated(request)) {
            out << body()
        }
    }

    def isNotAuthenticated = { attrs, body ->
        log.debug("CrowdAuthTagLib.isNotAuthenticated()")
        if (!CrowdAuthUtils.isAuthenticated(request)) {
            out << body()
        }
    }

    def authenticatedUserInfo = { attrs ->
        switch (attrs['property']) {
        case 'displayName':
            out << CrowdAuthUtils.getAuthenticatedPrincipal(request)?.
                    attributes.
                    toList().
                    find() { attribute ->
                        attribute.name == 'displayName'
                    }.
                    values
            break
        case 'name':
            def firstName= CrowdAuthUtils.getAuthenticatedPrincipal(request)?.attributes.toList().find() { attribute -> attribute.name == 'givenName' }.values.join()
            def lastName= CrowdAuthUtils.getAuthenticatedPrincipal(request)?.attributes.toList().find() { attribute -> attribute.name == 'sn' }.values.join()
            out << "${firstName} ${lastName}"
        }
    }
}
